// Generated by gtkmmproc -- DO NOT MODIFY!

#include <libgdamm/connection.h>
#include <libgdamm/private/connection_p.h>

/* $Id: connection.ccg,v 1.10 2004/04/29 23:07:13 murrayc Exp $ */
// -*- C++ -*- // 

/* connection.cc
 * 
 * Copyright 2003 libgdamm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <libgdamm/client.h>
#include <libgdamm/command.h>
#include <libgda/gda-enum-types.h>

namespace Gnome
{

namespace Gda
{

Connection::~Connection()
{
  //Make sure the connection is closed.
  //An open connection with no associated connection object could never be closed.
  if(gobj())
  {
    if(is_open())
      close();
  }
}
 
Glib::RefPtr<DataModel> Connection::get_schema(ConnectionSchema schema)
{
  return Glib::wrap(gda_connection_get_schema(gobj(), ((GdaConnectionSchema)(schema)), 0));
}

Glib::RefPtr<const DataModel> Connection::get_schema(ConnectionSchema schema) const
{
  return Glib::wrap(gda_connection_get_schema(const_cast<GdaConnection*>(gobj()), ((GdaConnectionSchema)(schema)), 0));
}

Glib::ListHandle< Glib::RefPtr<DataModel> > Connection::execute_command(const Command& cmd)
{
  return Glib::ListHandle< Glib::RefPtr<DataModel> >(gda_connection_execute_command(gobj(), const_cast<GdaCommand*>((cmd).gobj()), 0), Glib::OWNERSHIP_SHALLOW);
}

Glib::RefPtr<DataModel> Connection::execute_single_command(const Command& cmd)
{
  return Glib::wrap(gda_connection_execute_single_command(gobj(), const_cast<GdaCommand*>((cmd).gobj()), 0));
}

Glib::RefPtr<DataModel> Connection::execute_single_command(const Glib::ustring& cmd)
{
  Command command(cmd);
  return Glib::wrap(gda_connection_execute_single_command(gobj(), const_cast<GdaCommand*>((command).gobj()), 0));
}

int Connection::execute_non_query(const Command& cmd)
{
  return gda_connection_execute_non_query(gobj(), const_cast<GdaCommand*>((cmd).gobj()), 0);
}

bool Connection::close()
{
  //gda_connection_close() does an unref, but we don't want that:
  reference();
  return gda_connection_close(gobj());
}

} //namespace Gda

} //namespace Gnome


namespace
{

void Connection_signal_error_callback(GdaConnection* self, GList* p0,void* data)
{
  using namespace Gnome::Gda;
  typedef sigc::slot< void,GList* > SlotType;

  // Do not try to call a signal on a disassociated wrapper.
  if(Glib::ObjectBase::_get_current_wrapper((GObject*) self))
  {
    try
    {
      if(sigc::slot_base *const slot = Glib::SignalProxyNormal::data_to_slot(data))
        (*static_cast<SlotType*>(slot))(p0);
    }
    catch(...)
    {
      Glib::exception_handlers_invoke();
    }
  }
}

const Glib::SignalProxyInfo Connection_signal_error_info =
{
  "error",
  (GCallback) &Connection_signal_error_callback,
  (GCallback) &Connection_signal_error_callback
};

} // anonymous namespace

// static
GType Glib::Value<Gnome::Gda::ConnectionFeature>::value_type()
{
  return gda_connection_feature_get_type();
}

// static
GType Glib::Value<Gnome::Gda::ConnectionSchema>::value_type()
{
  return gda_connection_schema_get_type();
}

// static
GType Glib::Value<Gnome::Gda::ConnectionOptions>::value_type()
{
  return gda_connection_options_get_type();
}


namespace Glib
{

Glib::RefPtr<Gnome::Gda::Connection> wrap(GdaConnection* object, bool take_copy)
{
  return Glib::RefPtr<Gnome::Gda::Connection>( dynamic_cast<Gnome::Gda::Connection*> (Glib::wrap_auto ((GObject*)(object), take_copy)) );
  //We use dynamic_cast<> in case of multiple inheritance.
}

} /* namespace Glib */


namespace Gnome
{

namespace Gda
{


/* The *_Class implementation: */

const Glib::Class& Connection_Class::init()
{
  if(!gtype_) // create the GType if necessary
  {
    // Glib::Class has to know the class init function to clone custom types.
    class_init_func_ = &Connection_Class::class_init_function;

    // This is actually just optimized away, apparently with no harm.
    // Make sure that the parent type has been created.
    //CppClassParent::CppObjectType::get_type();

    // Create the wrapper type, with the same class/instance size as the base type.
    register_derived_type(gda_connection_get_type());

    // Add derived versions of interfaces, if the C type implements any interfaces:
  }

  return *this;
}

void Connection_Class::class_init_function(void* g_class, void* class_data)
{
  BaseClassType *const klass = static_cast<BaseClassType*>(g_class);
  CppClassParent::class_init_function(klass, class_data);

  klass->error = &error_callback;
}


void Connection_Class::error_callback(GdaConnection* self, GList* p0)
{
  CppObjectType *const obj = dynamic_cast<CppObjectType*>(
      Glib::ObjectBase::_get_current_wrapper((GObject*)self));

  // Non-gtkmmproc-generated custom classes implicitly call the default
  // Glib::ObjectBase constructor, which sets is_derived_. But gtkmmproc-
  // generated classes can use this optimisation, which avoids the unnecessary
  // parameter conversions if there is no possibility of the virtual function
  // being overridden:
  if(obj && obj->is_derived_())
  {
    try // Trap C++ exceptions which would normally be lost because this is a C callback.
    {
      // Call the virtual member method, which derived classes might override.
      obj->on_error(p0);
    }
    catch(...)
    {
      Glib::exception_handlers_invoke();
    }
  }
  else
  {
    BaseClassType *const base = static_cast<BaseClassType*>(
        g_type_class_peek_parent(G_OBJECT_GET_CLASS(self)) // Get the parent class of the object class (The original underlying C class).
    );

    // Call the original underlying C function:
    if(base && base->error)
      (*base->error)(self, p0);
  }
}


Glib::ObjectBase* Connection_Class::wrap_new(GObject* object)
{
  return new Connection((GdaConnection*)object);
}


/* The implementation: */

GdaConnection* Connection::gobj_copy()
{
  reference();
  return gobj();
}

Connection::Connection(const Glib::ConstructParams& construct_params)
:
  Glib::Object(construct_params)
{}

Connection::Connection(GdaConnection* castitem)
:
  Glib::Object((GObject*)(castitem))
{}


Connection::CppClassType Connection::connection_class_; // initialize static member

GType Connection::get_type()
{
  return connection_class_.init().get_type();
}

GType Connection::get_base_type()
{
  return gda_connection_get_type();
}


Connection::Connection()
:
  Glib::ObjectBase(0), //Mark this class as gtkmmproc-generated, rather than a custom class, to allow vfunc optimisations.
  Glib::Object(Glib::ConstructParams(connection_class_.init()))
{
  }

Glib::RefPtr<Connection> Connection::create()
{
  return Glib::RefPtr<Connection>( new Connection() );
}
bool Connection::is_open() const
{
  return gda_connection_is_open(const_cast<GdaConnection*>(gobj()));
}

Glib::RefPtr<Client> Connection::get_client()
{

  Glib::RefPtr<Client> retvalue = Glib::wrap(gda_connection_get_client(gobj()));

  if(retvalue)
    retvalue->reference(); //The function does not do a ref for us.
  return retvalue;
}

Glib::RefPtr<const Client> Connection::get_client() const
{

  Glib::RefPtr<const Client> retvalue = Glib::wrap(gda_connection_get_client(const_cast<GdaConnection*>(gobj())));

  if(retvalue)
    retvalue->reference(); //The function does not do a ref for us.
  return retvalue;
}

void Connection::set_client(const Glib::RefPtr<Client>& client)
{
  gda_connection_set_client(gobj(), Glib::unwrap(client));
}

ConnectionOptions Connection::get_options() const
{
  return ((ConnectionOptions)(gda_connection_get_options(const_cast<GdaConnection*>(gobj()))));
}

Glib::ustring Connection::get_server_version() const
{
  return Glib::convert_const_gchar_ptr_to_ustring(gda_connection_get_server_version(const_cast<GdaConnection*>(gobj())));
}

Glib::ustring Connection::get_database() const
{
  return Glib::convert_const_gchar_ptr_to_ustring(gda_connection_get_database(const_cast<GdaConnection*>(gobj())));
}

Glib::ustring Connection::get_dsn() const
{
  return Glib::convert_const_gchar_ptr_to_ustring(gda_connection_get_dsn(const_cast<GdaConnection*>(gobj())));
}

Glib::ustring Connection::get_cnc_string() const
{
  return Glib::convert_const_gchar_ptr_to_ustring(gda_connection_get_cnc_string(const_cast<GdaConnection*>(gobj())));
}

Glib::ustring Connection::get_provider() const
{
  return Glib::convert_const_gchar_ptr_to_ustring(gda_connection_get_provider(const_cast<GdaConnection*>(gobj())));
}

Glib::ustring Connection::get_username() const
{
  return Glib::convert_const_gchar_ptr_to_ustring(gda_connection_get_username(const_cast<GdaConnection*>(gobj())));
}

Glib::ustring Connection::get_password() const
{
  return Glib::convert_const_gchar_ptr_to_ustring(gda_connection_get_password(const_cast<GdaConnection*>(gobj())));
}

void Connection::add_error(const Glib::RefPtr<Error>& error)
{
  gda_connection_add_error(gobj(), Glib::unwrap(error));
}

void Connection::add_error(const Glib::ustring& error)
{
  gda_connection_add_error_string(gobj(), error.c_str());
}

void Connection::add_error_list(GList * error_list)
{
  gda_connection_add_error_list(gobj(), error_list);
}

bool Connection::change_database(const Glib::ustring& name)
{
  return gda_connection_change_database(gobj(), name.c_str());
}

bool Connection::create_database(const Glib::ustring& name)
{
  return gda_connection_create_database(gobj(), name.c_str());
}

bool Connection::drop_database(const Glib::ustring& name)
{
  return gda_connection_drop_database(gobj(), name.c_str());
}

Glib::ListHandle< Glib::RefPtr<DataModel> > Connection::execute_command(const Command& cmd, const ParameterList& params)
{
  return Glib::ListHandle< Glib::RefPtr<DataModel> >(gda_connection_execute_command(gobj(), const_cast<GdaCommand*>((cmd).gobj()), const_cast<GdaParameterList*>((params).gobj())), Glib::OWNERSHIP_SHALLOW);
}

Glib::RefPtr<DataModel> Connection::execute_single_command(const Command& cmd, const ParameterList& params)
{
  return Glib::wrap(gda_connection_execute_single_command(gobj(), const_cast<GdaCommand*>((cmd).gobj()), const_cast<GdaParameterList*>((params).gobj())));
}

int Connection::execute_non_query(const Command& cmd, const ParameterList& params)
{
  return gda_connection_execute_non_query(gobj(), const_cast<GdaCommand*>((cmd).gobj()), const_cast<GdaParameterList*>((params).gobj()));
}

bool Connection::begin_transaction(const Glib::RefPtr<Transaction>& transaction)
{
  return gda_connection_begin_transaction(gobj(), Glib::unwrap(transaction));
}

bool Connection::commit_transaction(const Glib::RefPtr<Transaction>& transaction)
{
  return gda_connection_commit_transaction(gobj(), Glib::unwrap(transaction));
}

bool Connection::rollback_transaction(const Glib::RefPtr<Transaction>& transaction)
{
  return gda_connection_rollback_transaction(gobj(), Glib::unwrap(transaction));
}

Glib::ListHandle< Glib::RefPtr<Error> > Connection::get_errors()
{
  return Glib::ListHandle< Glib::RefPtr<Error> >((GList*)gda_connection_get_errors(gobj()), Glib::OWNERSHIP_SHALLOW);
}

Glib::ListHandle< Glib::RefPtr<const Error> > Connection::get_errors() const
{
  return Glib::ListHandle< Glib::RefPtr<const Error> >((GList*)gda_connection_get_errors(const_cast<GdaConnection*>(gobj())), Glib::OWNERSHIP_SHALLOW);
}

bool Connection::create_blob(GdaBlob* blob)
{
  return gda_connection_create_blob(gobj(), blob);
}

bool Connection::supports(ConnectionFeature feature) const
{
  return gda_connection_supports(const_cast<GdaConnection*>(gobj()), ((GdaConnectionFeature)(feature)));
}

Glib::RefPtr<DataModel> Connection::get_schema(ConnectionSchema schema, const ParameterList& params)
{
  return Glib::wrap(gda_connection_get_schema(gobj(), ((GdaConnectionSchema)(schema)), const_cast<GdaParameterList*>((params).gobj())));
}

Glib::RefPtr<const DataModel> Connection::get_schema(ConnectionSchema schema, const ParameterList& params) const
{
  return Glib::wrap(gda_connection_get_schema(const_cast<GdaConnection*>(gobj()), ((GdaConnectionSchema)(schema)), const_cast<GdaParameterList*>((params).gobj())));
}

Glib::ustring Connection::get_last_insert_id(const Glib::RefPtr<DataModel>& recset) const
{
  return Glib::convert_return_gchar_ptr_to_ustring(gda_connection_get_last_insert_id(const_cast<GdaConnection*>(gobj()), Glib::unwrap(recset)));
}


Glib::SignalProxy1< void,GList* > Connection::signal_error()
{
  return Glib::SignalProxy1< void,GList* >(this, &Connection_signal_error_info);
}


void Gnome::Gda::Connection::on_error(GList* error_list)
{
  BaseClassType *const base = static_cast<BaseClassType*>(
      g_type_class_peek_parent(G_OBJECT_GET_CLASS(gobject_)) // Get the parent class of the object class (The original underlying C class).
  );

  if(base && base->error)
    (*base->error)(gobj(),error_list);
}


} // namespace Gda

} // namespace Gnome


